package com.advanstar.test.servlet;

import org.hornetq.core.config.Configuration;
import org.hornetq.core.config.impl.ConfigurationImpl;
import org.hornetq.core.config.impl.FileConfiguration;
import org.hornetq.core.remoting.impl.invm.InVMAcceptorFactory;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;
import org.hornetq.core.server.HornetQServer;
import org.hornetq.core.server.HornetQServers;
import org.hornetq.core.settings.impl.AddressSettings;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.SimpleString;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ClientSession;
import org.apache.commons.lang.time.StopWatch;

/**
 * User: a_vijay
 * Date: Feb 8, 2010
 * Time: 11:20:11 PM
 * To change this template use File | Settings | File Templates.
 */
public class MessageSendAndReceive {

    public static final String QUEUE_NAME = "queue.TestQueue12";

    private static SessionPool sessionPool = null;
    private static void loadMServer(){
        try{
            Configuration configuration = new ConfigurationImpl();
          //FileConfiguration configuration = new FileConfiguration();
          //configuration.setConfigurationUrl("D:\\Projects\\advanstar\\scrap_book\\src\\com\\advanstar\\test\\servlet\\hornetq-configuration.xml");

          configuration.setPersistenceEnabled(true);
          configuration.setSecurityEnabled(false);
          configuration.setBindingsDirectory("D:/hq/bindings");
          configuration.setJournalDirectory("D:/hq/journal");
          configuration.getAcceptorConfigurations().add(new TransportConfiguration(InVMAcceptorFactory.class.getName()));
            


          //configuration.set


          // Step 2. Create and start the server
          HornetQServer server = HornetQServers.newHornetQServer(configuration);
          AddressSettings settings = new AddressSettings();
          settings.setDeadLetterAddress(new SimpleString("queue.DLQ"));
          //settings.setExpiryAddress(new SimpleString("jms.queue.DLQ"));
          //settings.setRedeliveryDelay(5000);
          settings.setMaxDeliveryAttempts(3);
          server.getAddressSettingsRepository().setDefault(settings);
          //server.getAddressSettingsRepository().addMatch("queue.TestQueue11",settings);
          server.start();

          // Step 3. As we are not using a JNDI environment we instantiate the objects directly
         ClientSessionFactory sf = HornetQClient.createClientSessionFactory(new TransportConfiguration(InVMConnectorFactory.class.getName()));


          // Step 4. Create a core queue
         ClientSession coreSession = sf.createTransactedSession();

          //final String queueName = "queue.TestQueue4";
          //coreSession.queueQuery()

         coreSession.createQueue(QUEUE_NAME, QUEUE_NAME, true);
         coreSession.createQueue("queue.DLQ","queue.DLQ",true);

         coreSession.close();

          System.err.println("**********Server Started***********");
          System.err.println(" initialised with JMS Queue" );
        }catch(Exception ex) {
            ex.printStackTrace();
        }

    }


    public static ClientSession getSession() throws Exception{
        ClientSession session =  sessionPool.borrowSession();
        System.out.println(sessionPool.getPoolStatus());
        return session;

    }
    
    public static void closeSession(ClientSession session){
          sessionPool.returnSession(session);
    }



    public static void main(String[] args) throws Exception{
        loadMServer();
        sessionPool = new SessionPool(10);
        StopWatch stopWatch = new StopWatch();
        stopWatch.start();


        MessageReceiver receiver = new MessageReceiver();
        receiver.receiveMessage();

        MessagePusher pusher = new MessagePusher();
        pusher.sendMessage(0);


//        Thread.sleep(1000);
//        pusher.sendMessage(130);
//
//        Thread.sleep(1000);
//
//        pusher.sendMessage(260);
//
//        Thread.sleep(1000);
//
//         pusher.sendMessage(390);
//
//        pusher.sendMessage(520);

        stopWatch.stop();
        System.out.println("Timetook for Processing==> " + stopWatch.toString());


        //pusher.sendMessage();





    }
}
