package com.advanstar.test.servlet;

import org.apache.commons.pool.PoolableObjectFactory;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;

/**
 * User: a_vijay
 * Date: Feb 11, 2010
 * Time: 1:45:56 AM
 * To change this template use File | Settings | File Templates.
 */
public class SessionPoolFactory implements PoolableObjectFactory{

    private static ClientSessionFactory sessionFactory;

    static{
        sessionFactory = HornetQClient.createClientSessionFactory(new TransportConfiguration(InVMConnectorFactory.class.getName()));
        sessionFactory.setAckBatchSize(20);
    }

    
    @Override
    public Object makeObject() throws Exception {
        return sessionFactory.createTransactedSession();
    }

    @Override
    public void destroyObject(Object o) throws Exception {
        ClientSession session = (ClientSession)o;
        session.close();
    }

    @Override
    public boolean validateObject(Object o) {
        return true;  //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    public void activateObject(Object o) throws Exception {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    public void passivateObject(Object o) throws Exception {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
